/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20191125

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "conf.y"
/*
 * $Id: conf.y,v 1.26 2005/04/17 15:20:32 nohar Exp $
 *
 * This file is part of the bip proproject
 * Copyright (C) 2004 Arnaud Cornet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#include <stdlib.h>
#include "util.h"
#include "irc.h"
#include "tuple.h"
extern int yylex (void);
extern char *yytext;
extern int linec;

#define YYMALLOC bip_malloc

extern int yyerror(char *);

int yywrap()
{
	return 1;
}

/*int yydebug = 1;*/

list_t *root_list;

struct tuple *tuple_i_new(int type, int i)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->ndata = i;
	t->tuple_type = TUPLE_INT;
	return t;
}

struct tuple *tuple_p_new(int type, void *p)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->pdata = p;
	return t;
}

struct tuple *tuple_s_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_STR;
	return t;
}

struct tuple *tuple_l_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_LIST;
	return t;
}

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 73 "conf.y"
typedef union {
	int number;
	char *string;
	void *list;
	struct tuple *tuple;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 103 "conf.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define LEX_IP 257
#define LEX_EQ 258
#define LEX_PORT 259
#define LEX_CSS 260
#define LEX_SEMICOLON 261
#define LEX_CONNECTION 262
#define LEX_NETWORK 263
#define LEX_LBRA 264
#define LEX_RBRA 265
#define LEX_USER 266
#define LEX_NAME 267
#define LEX_NICK 268
#define LEX_SERVER 269
#define LEX_PASSWORD 270
#define LEX_SRCIP 271
#define LEX_HOST 272
#define LEX_VHOST 273
#define LEX_SOURCE_PORT 274
#define LEX_NONE 275
#define LEX_COMMENT 276
#define LEX_BUNCH 277
#define LEX_REALNAME 278
#define LEX_SSL 279
#define LEX_SSL_CHECK_MODE 280
#define LEX_SSL_CHECK_STORE 281
#define LEX_SSL_CLIENT_CERTFILE 282
#define LEX_CIPHERS 283
#define LEX_CSS_CIPHERS 284
#define LEX_DEFAULT_CIPHERS 285
#define LEX_DH_PARAM 286
#define LEX_CHANNEL 287
#define LEX_KEY 288
#define LEX_LOG_ROOT 289
#define LEX_LOG_FORMAT 290
#define LEX_LOG_LEVEL 291
#define LEX_BACKLOG_LINES 292
#define LEX_BACKLOG_NO_TIMESTAMP 293
#define LEX_BACKLOG 294
#define LEX_LOG 295
#define LEX_LOG_SYSTEM 296
#define LEX_LOG_SYNC_INTERVAL 297
#define LEX_FOLLOW_NICK 298
#define LEX_ON_CONNECT_SEND 299
#define LEX_AWAY_NICK 300
#define LEX_PID_FILE 301
#define LEX_WRITE_OIDENTD 302
#define LEX_OIDENTD_FILE 303
#define LEX_IGN_FIRST_NICK 304
#define LEX_ALWAYS_BACKLOG 305
#define LEX_BLRESET_ON_TALK 306
#define LEX_BLRESET_CONNECTION 307
#define LEX_DEFAULT_USER 308
#define LEX_DEFAULT_NICK 309
#define LEX_DEFAULT_REALNAME 310
#define LEX_NO_CLIENT_AWAY_MSG 311
#define LEX_BL_MSG_ONLY 312
#define LEX_ADMIN 313
#define LEX_BIP_USE_NOTICE 314
#define LEX_CSS_PEM 315
#define LEX_AUTOJOIN_ON_KICK 316
#define LEX_IGNORE_CAPAB 317
#define LEX_RECONN_TIMER 318
#define LEX_BOOL 319
#define LEX_INT 320
#define LEX_STRING 321
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    2,    2,    8,
    8,    8,    8,    4,    4,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,    5,    5,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,    3,    3,    9,    9,    9,    1,    1,
    7,    7,
};
static const YYINT yylen[] = {                            2,
    0,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    4,    4,    0,    3,    3,
    3,    3,    4,    0,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    4,    0,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    3,    3,    3,    0,    3,    3,    3,    3,    0,    3,
    3,    3,
};
static const YYINT yydefred[] = {                         1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   28,   34,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    2,    7,    8,    9,    0,    0,   11,   12,
   13,    3,    4,    5,   20,   21,   22,   14,   15,   16,
   17,   18,   19,   25,   23,   24,   10,    6,   26,    0,
    0,    0,    0,    0,    0,   27,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   79,    0,    0,   29,   54,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   35,   30,    0,
   31,   32,    0,   36,   37,   40,   41,   42,   46,   47,
   48,   52,   49,   50,   43,   44,   45,   51,   38,   39,
    0,   33,    0,    0,    0,   53,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   80,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   74,    0,    0,    0,
    0,    0,    0,    0,    0,   55,   82,   81,   57,   60,
   56,   59,   62,   63,   64,   61,   73,    0,   58,   66,
   71,   65,   67,   72,   68,   69,   70,    0,    0,    0,
    0,    0,    0,    0,   75,   76,   77,   78,
};
static const YYINT yydgoto[] = {                          1,
  130,   57,  208,   58,  133,   27,  154,   84,  221,  104,
  174,
};
static const YYINT yysindex[] = {                         0,
 -257, -251, -250, -245, -263, -259, -243, -239, -237, -236,
 -235, -234, -233, -227, -216, -215, -208, -207, -206, -205,
 -204, -202, -201, -199, -192, -190, -189, -310, -246, -241,
    0,    0, -252, -248, -242, -240, -232, -244, -238, -229,
 -228, -226, -225, -218, -217, -214, -212, -213, -200, -198,
 -188, -191,    0,    0,    0,    0, -253, -182,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -172,
 -177, -155, -151, -146, -148,    0, -141, -140, -138, -136,
 -124, -123, -122, -121, -120, -119, -118, -117, -116, -115,
 -114, -113, -112, -111, -174,    0, -171, -170,    0,    0,
 -169, -168, -167, -166, -165, -163, -161, -160, -159, -158,
 -157, -156, -154, -153, -150, -149, -147,    0,    0, -255,
    0,    0, -203,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -109,    0,  -95,  -97,  -92,    0,  -87,  -85,  -84,  -83,
  -82,  -81,  -80,  -79,  -78,  -77,  -76,  -75,  -74,  -73,
  -71,  -70,  -69,  -68, -130, -129,    0, -127, -126, -125,
 -110, -108, -107, -105, -104, -103,    0, -139, -128, -102,
 -101,  -98,  -99,  -96,  -94,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -247,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -61,  -60,  -59,
  -58,  -93,  -91,  -90,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 230
static const YYINT yytable[] = {                          2,
   31,    3,    4,  151,   32,    5,   28,   29,    6,  152,
   54,   79,   30,   80,   33,   81,  153,  217,   34,  218,
   35,   36,   37,   38,   39,   82,    7,    8,    9,   83,
   40,   10,   11,   12,   13,   14,   15,   16,   17,   18,
  219,   41,   42,   19,   20,   21,  220,   22,   23,   43,
   44,   45,   46,   47,   24,   48,   49,   25,   50,  155,
   26,  156,  157,  158,  159,   51,  160,   52,   59,  161,
  162,   53,   60,   55,  163,   64,  164,   56,   61,   85,
   62,   65,   86,  165,   87,  105,  106,   88,   63,   66,
   67,  166,   68,   69,  167,  168,  169,   89,   90,   91,
  170,   70,  107,   71,   72,   74,  108,  171,   73,   92,
   93,   94,  172,  173,  109,  110,  111,  112,   75,  113,
   76,  114,   95,   96,   97,   98,   99,  100,   78,  101,
  102,  103,   77,  115,  116,  117,  118,  119,  120,  121,
  122,  123,  124,  125,  126,  127,  129,  131,  175,  128,
  132,  134,  135,  136,  137,  138,  139,  140,  141,  142,
  143,  144,  176,  177,  145,  178,  146,  147,  148,  149,
  179,  150,  180,  181,  182,  183,  184,  185,  186,  209,
  188,  189,  190,  191,  192,  187,  193,  194,  195,  197,
  210,  198,  196,  199,  200,  201,  222,  223,  224,    0,
    0,    0,  225,    0,    0,    0,    0,    0,    0,    0,
  202,    0,  203,  204,  205,    0,  206,  207,  211,  212,
  213,  214,  215,    0,  216,    0,    0,  226,  228,  227,
};
static const YYINT yycheck[] = {                        257,
  264,  259,  260,  259,  264,  263,  258,  258,  266,  265,
  321,  265,  258,  267,  258,  269,  272,  265,  258,  267,
  258,  258,  258,  258,  258,  279,  284,  285,  286,  283,
  258,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  288,  258,  258,  301,  302,  303,  294,  305,  306,  258,
  258,  258,  258,  258,  312,  258,  258,  315,  258,  263,
  318,  265,  266,  267,  268,  258,  270,  258,  321,  273,
  274,  261,  321,  320,  278,  320,  280,  319,  321,  262,
  321,  320,  265,  287,  267,  258,  264,  270,  321,  319,
  319,  295,  319,  319,  298,  299,  300,  280,  281,  282,
  304,  320,  258,  321,  319,  319,  258,  311,  321,  292,
  293,  294,  316,  317,  261,  264,  258,  258,  319,  258,
  319,  258,  305,  306,  307,  308,  309,  310,  320,  312,
  313,  314,  321,  258,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  258,  321,  319,  258,  261,
  321,  321,  321,  321,  321,  321,  320,  319,  319,  319,
  319,  319,  258,  261,  321,  258,  321,  321,  319,  319,
  258,  319,  258,  258,  258,  258,  258,  258,  258,  319,
  258,  258,  258,  258,  258,  264,  258,  258,  258,  320,
  319,  321,  261,  321,  321,  321,  258,  258,  258,   -1,
   -1,   -1,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,  321,  321,  320,   -1,  321,  321,  321,  321,
  319,  321,  319,   -1,  319,   -1,   -1,  321,  319,  321,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 321
#define YYUNDFTOKEN 335
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LEX_IP","LEX_EQ","LEX_PORT",
"LEX_CSS","LEX_SEMICOLON","LEX_CONNECTION","LEX_NETWORK","LEX_LBRA","LEX_RBRA",
"LEX_USER","LEX_NAME","LEX_NICK","LEX_SERVER","LEX_PASSWORD","LEX_SRCIP",
"LEX_HOST","LEX_VHOST","LEX_SOURCE_PORT","LEX_NONE","LEX_COMMENT","LEX_BUNCH",
"LEX_REALNAME","LEX_SSL","LEX_SSL_CHECK_MODE","LEX_SSL_CHECK_STORE",
"LEX_SSL_CLIENT_CERTFILE","LEX_CIPHERS","LEX_CSS_CIPHERS","LEX_DEFAULT_CIPHERS",
"LEX_DH_PARAM","LEX_CHANNEL","LEX_KEY","LEX_LOG_ROOT","LEX_LOG_FORMAT",
"LEX_LOG_LEVEL","LEX_BACKLOG_LINES","LEX_BACKLOG_NO_TIMESTAMP","LEX_BACKLOG",
"LEX_LOG","LEX_LOG_SYSTEM","LEX_LOG_SYNC_INTERVAL","LEX_FOLLOW_NICK",
"LEX_ON_CONNECT_SEND","LEX_AWAY_NICK","LEX_PID_FILE","LEX_WRITE_OIDENTD",
"LEX_OIDENTD_FILE","LEX_IGN_FIRST_NICK","LEX_ALWAYS_BACKLOG",
"LEX_BLRESET_ON_TALK","LEX_BLRESET_CONNECTION","LEX_DEFAULT_USER",
"LEX_DEFAULT_NICK","LEX_DEFAULT_REALNAME","LEX_NO_CLIENT_AWAY_MSG",
"LEX_BL_MSG_ONLY","LEX_ADMIN","LEX_BIP_USE_NOTICE","LEX_CSS_PEM",
"LEX_AUTOJOIN_ON_KICK","LEX_IGNORE_CAPAB","LEX_RECONN_TIMER","LEX_BOOL",
"LEX_INT","LEX_STRING",0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : commands",
"commands :",
"commands : commands command LEX_SEMICOLON",
"command : LEX_LOG_ROOT LEX_EQ LEX_STRING",
"command : LEX_LOG_FORMAT LEX_EQ LEX_STRING",
"command : LEX_LOG_LEVEL LEX_EQ LEX_INT",
"command : LEX_RECONN_TIMER LEX_EQ LEX_INT",
"command : LEX_IP LEX_EQ LEX_STRING",
"command : LEX_PORT LEX_EQ LEX_INT",
"command : LEX_CSS LEX_EQ LEX_BOOL",
"command : LEX_CSS_PEM LEX_EQ LEX_STRING",
"command : LEX_CSS_CIPHERS LEX_EQ LEX_STRING",
"command : LEX_DEFAULT_CIPHERS LEX_EQ LEX_STRING",
"command : LEX_DH_PARAM LEX_EQ LEX_STRING",
"command : LEX_LOG LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYSTEM LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYNC_INTERVAL LEX_EQ LEX_INT",
"command : LEX_PID_FILE LEX_EQ LEX_STRING",
"command : LEX_WRITE_OIDENTD LEX_EQ LEX_BOOL",
"command : LEX_OIDENTD_FILE LEX_EQ LEX_STRING",
"command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_NETWORK LEX_LBRA network LEX_RBRA",
"command : LEX_USER LEX_LBRA user LEX_RBRA",
"network :",
"network : network net_command LEX_SEMICOLON",
"net_command : LEX_NAME LEX_EQ LEX_STRING",
"net_command : LEX_SSL LEX_EQ LEX_BOOL",
"net_command : LEX_CIPHERS LEX_EQ LEX_STRING",
"net_command : LEX_SERVER LEX_LBRA server LEX_RBRA",
"user :",
"user : user usr_command LEX_SEMICOLON",
"usr_command : LEX_NAME LEX_EQ LEX_STRING",
"usr_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"usr_command : LEX_ADMIN LEX_EQ LEX_BOOL",
"usr_command : LEX_BIP_USE_NOTICE LEX_EQ LEX_BOOL",
"usr_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CHECK_STORE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CLIENT_CERTFILE LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_USER LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_NICK LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_REALNAME LEX_EQ LEX_STRING",
"usr_command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"usr_command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"usr_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_CONNECTION LEX_EQ LEX_BOOL",
"usr_command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"usr_command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_CONNECTION LEX_LBRA connection LEX_RBRA",
"connection :",
"connection : connection con_command LEX_SEMICOLON",
"con_command : LEX_NAME LEX_EQ LEX_STRING",
"con_command : LEX_NETWORK LEX_EQ LEX_STRING",
"con_command : LEX_LOG LEX_EQ LEX_BOOL",
"con_command : LEX_NICK LEX_EQ LEX_STRING",
"con_command : LEX_USER LEX_EQ LEX_STRING",
"con_command : LEX_REALNAME LEX_EQ LEX_STRING",
"con_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"con_command : LEX_VHOST LEX_EQ LEX_STRING",
"con_command : LEX_SOURCE_PORT LEX_EQ LEX_INT",
"con_command : LEX_AWAY_NICK LEX_EQ LEX_STRING",
"con_command : LEX_FOLLOW_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_IGN_FIRST_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_AUTOJOIN_ON_KICK LEX_EQ LEX_BOOL",
"con_command : LEX_IGNORE_CAPAB LEX_EQ LEX_BOOL",
"con_command : LEX_CHANNEL LEX_LBRA channel LEX_RBRA",
"con_command : LEX_ON_CONNECT_SEND LEX_EQ LEX_STRING",
"con_command : LEX_NO_CLIENT_AWAY_MSG LEX_EQ LEX_STRING",
"con_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"channel :",
"channel : channel cha_command LEX_SEMICOLON",
"cha_command : LEX_NAME LEX_EQ LEX_STRING",
"cha_command : LEX_KEY LEX_EQ LEX_STRING",
"cha_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"server :",
"server : server ser_command LEX_SEMICOLON",
"ser_command : LEX_HOST LEX_EQ LEX_STRING",
"ser_command : LEX_PORT LEX_EQ LEX_INT",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 88 "conf.y"
	{ yyval.list = root_list = list_new(NULL); }
break;
case 2:
#line 89 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 3:
#line 93 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_ROOT, yystack.l_mark[0].string); }
break;
case 4:
#line 94 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_FORMAT,
						yystack.l_mark[0].string); }
break;
case 5:
#line 96 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_LEVEL, yystack.l_mark[0].number); }
break;
case 6:
#line 97 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_RECONN_TIMER, yystack.l_mark[0].number); }
break;
case 7:
#line 98 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_IP, yystack.l_mark[0].string); }
break;
case 8:
#line 99 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yystack.l_mark[0].number); }
break;
case 9:
#line 100 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_CSS, yystack.l_mark[0].number); }
break;
case 10:
#line 101 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_CSS_PEM, yystack.l_mark[0].string); }
break;
case 11:
#line 102 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_CSS_CIPHERS, yystack.l_mark[0].string); }
break;
case 12:
#line 103 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_DEFAULT_CIPHERS, yystack.l_mark[0].string); }
break;
case 13:
#line 104 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_DH_PARAM, yystack.l_mark[0].string); }
break;
case 14:
#line 105 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG, yystack.l_mark[0].number); }
break;
case 15:
#line 106 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_SYSTEM, yystack.l_mark[0].number); }
break;
case 16:
#line 107 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_LOG_SYNC_INTERVAL, yystack.l_mark[0].number); }
break;
case 17:
#line 109 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PID_FILE, yystack.l_mark[0].string); }
break;
case 18:
#line 110 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_WRITE_OIDENTD, yystack.l_mark[0].number); }
break;
case 19:
#line 111 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_OIDENTD_FILE, yystack.l_mark[0].string); }
break;
case 20:
#line 113 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yystack.l_mark[0].number);
		  }
break;
case 21:
#line 116 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yystack.l_mark[0].number);
	       }
break;
case 22:
#line 119 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 23:
#line 120 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yystack.l_mark[0].number);
	       }
break;
case 24:
#line 123 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yystack.l_mark[0].number);
	       }
break;
case 25:
#line 126 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yystack.l_mark[0].number); }
break;
case 26:
#line 129 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_NETWORK,
						yystack.l_mark[-1].list); }
break;
case 27:
#line 131 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_USER, yystack.l_mark[-1].list); }
break;
case 28:
#line 134 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 29:
#line 135 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 30:
#line 138 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 31:
#line 139 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_SSL, yystack.l_mark[0].number); }
break;
case 32:
#line 140 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_CIPHERS, yystack.l_mark[0].string); }
break;
case 33:
#line 141 "conf.y"
	{
			yyval.tuple = tuple_l_new(LEX_SERVER, yystack.l_mark[-1].list); }
break;
case 34:
#line 145 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 35:
#line 146 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 36:
#line 149 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 37:
#line 151 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		yystack.l_mark[0].string); }
break;
case 38:
#line 153 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_ADMIN, yystack.l_mark[0].number); }
break;
case 39:
#line 154 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_BIP_USE_NOTICE, yystack.l_mark[0].number); }
break;
case 40:
#line 156 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yystack.l_mark[0].string); }
break;
case 41:
#line 158 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_STORE, yystack.l_mark[0].string); }
break;
case 42:
#line 160 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CLIENT_CERTFILE, yystack.l_mark[0].string); }
break;
case 43:
#line 162 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_USER, yystack.l_mark[0].string); }
break;
case 44:
#line 164 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_NICK, yystack.l_mark[0].string); }
break;
case 45:
#line 166 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_REALNAME, yystack.l_mark[0].string); }
break;
case 46:
#line 168 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yystack.l_mark[0].number);
		  }
break;
case 47:
#line 171 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yystack.l_mark[0].number);
	       }
break;
case 48:
#line 174 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 49:
#line 175 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yystack.l_mark[0].number);
	       }
break;
case 50:
#line 178 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_CONNECTION, yystack.l_mark[0].number);
	       }
break;
case 51:
#line 181 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yystack.l_mark[0].number);
	       }
break;
case 52:
#line 184 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yystack.l_mark[0].number); }
break;
case 53:
#line 186 "conf.y"
	{
				 yyval.tuple = tuple_l_new(LEX_CONNECTION, yystack.l_mark[-1].list); }
break;
case 54:
#line 190 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 55:
#line 191 "conf.y"
	{
	       list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 56:
#line 195 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 57:
#line 196 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NETWORK,
			 yystack.l_mark[0].string); }
break;
case 58:
#line 198 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG, yystack.l_mark[0].number); }
break;
case 59:
#line 199 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NICK, yystack.l_mark[0].string); }
break;
case 60:
#line 200 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_USER, yystack.l_mark[0].string); }
break;
case 61:
#line 201 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_REALNAME,
		 yystack.l_mark[0].string); }
break;
case 62:
#line 203 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		 yystack.l_mark[0].string); }
break;
case 63:
#line 205 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_VHOST, yystack.l_mark[0].string); }
break;
case 64:
#line 206 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_SOURCE_PORT, yystack.l_mark[0].number); }
break;
case 65:
#line 208 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_AWAY_NICK,
						yystack.l_mark[0].string); }
break;
case 66:
#line 210 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_FOLLOW_NICK, yystack.l_mark[0].number); }
break;
case 67:
#line 212 "conf.y"
	{ yyval.tuple = tuple_i_new(
					   LEX_IGN_FIRST_NICK, yystack.l_mark[0].number); }
break;
case 68:
#line 214 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_AUTOJOIN_ON_KICK, yystack.l_mark[0].number); }
break;
case 69:
#line 216 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_IGNORE_CAPAB, yystack.l_mark[0].number); }
break;
case 70:
#line 218 "conf.y"
	{ yyval.tuple = tuple_l_new(
						LEX_CHANNEL, yystack.l_mark[-1].list); }
break;
case 71:
#line 220 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_ON_CONNECT_SEND, yystack.l_mark[0].string); }
break;
case 72:
#line 222 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_NO_CLIENT_AWAY_MSG, yystack.l_mark[0].string); }
break;
case 73:
#line 224 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yystack.l_mark[0].string); }
break;
case 74:
#line 227 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 75:
#line 228 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 76:
#line 231 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yystack.l_mark[0].string); }
break;
case 77:
#line 232 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_KEY, yystack.l_mark[0].string); }
break;
case 78:
#line 233 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yystack.l_mark[0].number); }
break;
case 79:
#line 236 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 80:
#line 237 "conf.y"
	{ list_add_last(yystack.l_mark[-2].list, yystack.l_mark[-1].tuple); yyval.list = yystack.l_mark[-2].list; }
break;
case 81:
#line 240 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_HOST, yystack.l_mark[0].string); }
break;
case 82:
#line 241 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yystack.l_mark[0].number); }
break;
#line 1093 "conf.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
